"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.concat2 = exports.sequenceAIM = exports.sequenceAW = exports.sequenceATE = exports.traverseAIM = exports.traverseATE = exports.traverseAE = exports.traverseATs = void 0;
const Array = require("fp-ts/lib/Array");
const Either = require("fp-ts/lib/Either");
const Task = require("fp-ts/lib/Task");
const TaskEither = require("fp-ts/lib/TaskEither");
const function_1 = require("fp-ts/lib/function");
const Warn = require("./Warn");
exports.traverseATs = Array.array.traverse(Task.taskSeq);
exports.traverseAE = Array.array.traverse(Either.either);
exports.traverseATE = Array.array.traverse(TaskEither.taskEither);
function traverseAIM(ta, f) {
    return (0, function_1.pipe)((0, exports.traverseATE)(ta, f), TaskEither.map(exports.sequenceAW));
}
exports.traverseAIM = traverseAIM;
exports.sequenceATE = Array.array.sequence(TaskEither.taskEither);
exports.sequenceAW = Array.array.sequence(Warn.warn_);
function sequenceAIM(ta) {
    return (0, function_1.pipe)((0, exports.sequenceATE)(ta), TaskEither.map(exports.sequenceAW));
}
exports.sequenceAIM = sequenceAIM;
const concat2 = () => (arr1) => (arr2) => [...arr1, ...arr2];
exports.concat2 = concat2;
