"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parenthesized = exports.optional = void 0;
const typed_parser_1 = require("../typed-parser");
const token_1 = require("./token");
function optional(parser) {
    return (0, typed_parser_1.oneOf)(parser, (0, typed_parser_1.seqNull)((0, typed_parser_1.constant)('')));
}
exports.optional = optional;
// ( ... )
function parenthesized(parser) {
    return (0, typed_parser_1.seq2)((0, token_1.symbol)('('), parser, (0, token_1.symbol)(')'));
}
exports.parenthesized = parenthesized;
